## scitokens-cpp 0.5.1

=== CMakeLists.txt ===

cmake_minimum_required( VERSION 2.6 )
project( scitokens-cpp )

option( BUILD_UNITTESTS "Build the scitokens-cpp unit tests" OFF )

set( CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake )

find_package( jwt-cpp REQUIRED )
find_package( CURL REQUIRED )
find_package( UUID REQUIRED )

if( CMAKE_COMPILER_IS_GNUCXX )
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Werror" )
endif()

if( CMAKE_COMPILER_IS_GNUCC )
  set(CMAKE_CXX_FLAGS "${CMAKE_C_FLAGS} -Wall -Werror" )
endif()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -g")


if( APPLE )

find_package( OpenSSL REQUIRED )
find_package( Sqlite3 REQUIRED )
set(LIBCRYPTO_INCLUDE_DIRS ${OPENSSL_INCLUDE_DIR})
set(LIBCRYPTO_LIBRARIES ${OPENSSL_CRYPTO_LIBRARY})
set(CMAKE_MACOSX_RPATH ON)

elseif( UNIX )

include (FindPkgConfig)
pkg_check_modules(LIBCRYPTO REQUIRED libcrypto)
pkg_check_modules(OPENSSL REQUIRED openssl)
pkg_check_modules(SQLITE REQUIRED sqlite3)

# pkg_check_modules fails to return an absolute path on RHEL7.  Set the
# link directories accordingly.
link_directories(${OPENSSL_LIBRARY_DIRS} ${LIBCRYPTO_LIBRARY_DIRS})
endif()

include_directories( "${PROJECT_SOURCE_DIR}" ${JWT_CPP_INCLUDES} ${CURL_INCLUDES} ${OPENSSL_INCLUDE_DIRS} ${LIBCRYPTO_INCLUDE_DIRS} ${SQLITE_INCLUDE_DIRS}  ${UUID_INCLUDE_DIRS} )

add_library(SciTokens SHARED src/scitokens.cpp src/scitokens_internal.cpp src/scitokens_cache.cpp)
target_link_libraries(SciTokens ${OPENSSL_LIBRARIES} ${LIBCRYPTO_LIBRARIES} ${CURL_LIBRARIES} ${SQLITE_LIBRARIES} ${UUID_LIBRARIES})

if ( NOT APPLE AND UNIX )
set_target_properties(SciTokens PROPERTIES LINK_FLAGS "-Wl,--version-script=${PROJECT_SOURCE_DIR}/configs/export-symbols")
endif()

add_executable(scitokens-test src/test.cpp)
target_link_libraries(scitokens-test SciTokens)

add_executable(scitokens-verify src/verify.cpp)
target_link_libraries(scitokens-verify SciTokens)

add_executable(scitokens-test-access src/test_access.cpp)
target_link_libraries(scitokens-test-access SciTokens)

add_executable(scitokens-list-access src/list_access.cpp)
target_link_libraries(scitokens-list-access SciTokens)

add_executable(scitokens-create src/create.cpp)
target_link_libraries(scitokens-create SciTokens)

if (NOT DEFINED LIB_INSTALL_DIR)
  SET(LIB_INSTALL_DIR "lib")
endif()

if (NOT DEFINED INCLUDE_INSTALL_DIR)
  SET(INCLUDE_INSTALL_DIR "include")
endif()

if( BUILD_UNITTESTS )

include(ExternalProject)
ExternalProject_Add(gtest
    PREFIX external/gtest
    URL file://${PROJECT_SOURCE_DIR}/vendor/gtest
    INSTALL_COMMAND :
)
enable_testing()
add_subdirectory(test)
endif()

install(
  TARGETS SciTokens
  LIBRARY DESTINATION ${LIB_INSTALL_DIR} )

install(
  FILES src/scitokens.h
  DESTINATION ${INCLUDE_INSTALL_DIR}/scitokens )

set_target_properties(
  SciTokens
  PROPERTIES
  VERSION   "0.0.2"
  SOVERSION "0"
  )

=== test/CMakeLists.txt ===

add_executable(scitokens-gtest main.cpp)
add_dependencies(scitokens-gtest gtest)
include_directories("${PROJECT_SOURCE_DIR}/vendor/gtest/googletest/include")

target_link_libraries(scitokens-gtest SciTokens "${CMAKE_BINARY_DIR}/external/gtest/src/gtest-build/lib/libgtest.a" -lpthread)

add_test(
  NAME
    unit
  COMMAND
    ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_BINDIR}/test/scitokens-gtest
  )

=== vendor/jwt-cpp/Makefile ===
SRC = $(shell find . -name '*.cpp') $(shell find . -name '*.c')
HEADERS = $(shell find . -name '*.h')
EXCLUDE_SRC = 
FSRC = $(filter-out $(EXCLUDE_SRC), $(SRC))
OBJ = $(FSRC:=.o)

DEP_DIR = .deps

FLAGS = -fPIC -Wall -Wno-unknown-pragmas -Werror -I include
CXXFLAGS = -std=c++11
CFLAGS = 
LINKFLAGS = -lcrypto -lgtest -lpthread

OUTFILE = test

.PHONY: clean debug release

all: debug

debug: FLAGS += -g
debug: $(OUTFILE)

release: FLAGS += -O2 -march=native
release: $(OUTFILE)

$(OUTFILE): $(OBJ)
	@echo Generating binary
	@$(CXX) -o $@ $^ $(LINKFLAGS)
	@echo Build done

%.cc.o: %.cc
	@echo Building $<
	@$(CXX) -c $(FLAGS) $(CXXFLAGS) $< -o $@
	@mkdir -p `dirname $(DEP_DIR)/$@.d`
	@$(CXX) -c $(FLAGS) $(CXXFLAGS) -MT '$@' -MM $< > $(DEP_DIR)/$@.d

%.cpp.o: %.cpp
	@echo Building $<
	@$(CXX) -c $(FLAGS) $(CXXFLAGS) $< -o $@
	@mkdir -p `dirname $(DEP_DIR)/$@.d`
	@$(CXX) -c $(FLAGS) $(CXXFLAGS) -MT '$@' -MM $< > $(DEP_DIR)/$@.d

%.c.o: %.c
	@echo Building $<
	@$(CC) -c $(FLAGS) $(CFLAGS) $< -o $@
	@mkdir -p `dirname $(DEP_DIR)/$@.d`
	@$(CC) -c $(FLAGS) $(CFLAGS) -MT '$@' -MM $< > $(DEP_DIR)/$@.d

clean:
	@echo Removing binary
	@rm -f $(OUTFILE)
	@echo Removing objects
	@rm -f $(OBJ)
	@echo Removing dependency files
	@rm -rf $(DEP_DIR)

-include $(OBJ:%=$(DEP_DIR)/%.d)

=== vendor/gtest/googletest/CMakeLists.txt ===
########################################################################
# Note: CMake support is community-based. The maintainers do not use CMake
# internally.
#
# CMake build script for Google Test.
#
# To run the tests for Google Test itself on Linux, use 'make test' or
# ctest.  You can select which tests to run using 'ctest -R regex'.
# For more options, run 'ctest --help'.

# When other libraries are using a shared version of runtime libraries,
# Google Test also has to use one.
option(
  gtest_force_shared_crt
  "Use shared (DLL) run-time lib even when Google Test is built as static lib."
  OFF)

option(gtest_build_tests "Build all of gtest's own tests." OFF)

option(gtest_build_samples "Build gtest's sample programs." OFF)

option(gtest_disable_pthreads "Disable uses of pthreads in gtest." OFF)

option(
  gtest_hide_internal_symbols
  "Build gtest with internal symbols hidden in shared libraries."
  OFF)

# Defines pre_project_set_up_hermetic_build() and set_up_hermetic_build().
include(cmake/hermetic_build.cmake OPTIONAL)

if (COMMAND pre_project_set_up_hermetic_build)
  pre_project_set_up_hermetic_build()
endif()

########################################################################
#
# Project-wide settings

# Name of the project.
#
# CMake files in this project can refer to the root source directory
# as ${gtest_SOURCE_DIR} and to the root binary directory as
# ${gtest_BINARY_DIR}.
# Language "C" is required for find_package(Threads).

# Project version:

if (CMAKE_VERSION VERSION_LESS 3.0)
  project(gtest CXX C)
  set(PROJECT_VERSION ${GOOGLETEST_VERSION})
else()
  cmake_policy(SET CMP0048 NEW)
  project(gtest VERSION ${GOOGLETEST_VERSION} LANGUAGES CXX C)
endif()
cmake_minimum_required(VERSION 2.6.4)

if (POLICY CMP0063) # Visibility
  cmake_policy(SET CMP0063 NEW)
endif (POLICY CMP0063)

if (COMMAND set_up_hermetic_build)
  set_up_hermetic_build()
endif()

# These commands only run if this is the main project
if(CMAKE_PROJECT_NAME STREQUAL "gtest" OR CMAKE_PROJECT_NAME STREQUAL "googletest-distribution")

  # BUILD_SHARED_LIBS is a standard CMake variable, but we declare it here to
  # make it prominent in the GUI.
  option(BUILD_SHARED_LIBS "Build shared libraries (DLLs)." OFF)

else()

  mark_as_advanced(
    gtest_force_shared_crt
    gtest_build_tests
    gtest_build_samples
    gtest_disable_pthreads
    gtest_hide_internal_symbols)

endif()


if (gtest_hide_internal_symbols)
  set(CMAKE_CXX_VISIBILITY_PRESET hidden)
  set(CMAKE_VISIBILITY_INLINES_HIDDEN 1)
endif()

# Define helper functions and macros used by Google Test.
include(cmake/internal_utils.cmake)

config_compiler_and_linker()  # Defined in internal_utils.cmake.

# Create the CMake package file descriptors.
if (INSTALL_GTEST)
  include(CMakePackageConfigHelpers)
  set(cmake_package_name GTest)
  set(targets_export_name ${cmake_package_name}Targets CACHE INTERNAL "")
  set(generated_dir "${CMAKE_CURRENT_BINARY_DIR}/generated" CACHE INTERNAL "")
  set(cmake_files_install_dir "${CMAKE_INSTALL_LIBDIR}/cmake/${cmake_package_name}")
  set(version_file "${generated_dir}/${cmake_package_name}ConfigVersion.cmake")
  write_basic_package_version_file(${version_file} VERSION ${GOOGLETEST_VERSION} COMPATIBILITY AnyNewerVersion)
  install(EXPORT ${targets_export_name}
    NAMESPACE ${cmake_package_name}::
    DESTINATION ${cmake_files_install_dir})
  set(config_file "${generated_dir}/${cmake_package_name}Config.cmake")
  configure_package_config_file("${gtest_SOURCE_DIR}/cmake/Config.cmake.in"
    "${config_file}" INSTALL_DESTINATION ${cmake_files_install_dir})
  install(FILES ${version_file} ${config_file}
    DESTINATION ${cmake_files_install_dir})
endif()

# Where Google Test's .h files can be found.
set(gtest_build_include_dirs
  "${gtest_SOURCE_DIR}/include"
  "${gtest_SOURCE_DIR}")
include_directories(${gtest_build_include_dirs})

########################################################################
#
# Defines the gtest & gtest_main libraries.  User tests should link
# with one of them.

# Google Test libraries.  We build them using more strict warnings than what
# are used for other targets, to ensure that gtest can be compiled by a user
# aggressive about warnings.
cxx_library(gtest "${cxx_strict}" src/gtest-all.cc)
cxx_library(gtest_main "${cxx_strict}" src/gtest_main.cc)
# If the CMake version supports it, attach header directory information
# to the targets for when we are part of a parent build (ie being pulled
# in via add_subdirectory() rather than being a standalone build).
if (DEFINED CMAKE_VERSION AND NOT "${CMAKE_VERSION}" VERSION_LESS "2.8.11")
  target_include_directories(gtest SYSTEM INTERFACE
    "$<BUILD_INTERFACE:${gtest_build_include_dirs}>"
    "$<INSTALL_INTERFACE:$<INSTALL_PREFIX>/${CMAKE_INSTALL_INCLUDEDIR}>")
  target_include_directories(gtest_main SYSTEM INTERFACE
    "$<BUILD_INTERFACE:${gtest_build_include_dirs}>"
    "$<INSTALL_INTERFACE:$<INSTALL_PREFIX>/${CMAKE_INSTALL_INCLUDEDIR}>")
endif()
target_link_libraries(gtest_main PUBLIC gtest)

########################################################################
#
# Install rules
install_project(gtest gtest_main)

########################################################################
#
# Samples on how to link user tests with gtest or gtest_main.
#
# They are not built by default.  To build them, set the
# gtest_build_samples option to ON.  You can do it by running ccmake
# or specifying the -Dgtest_build_samples=ON flag when running cmake.

if (gtest_build_samples)
  cxx_executable(sample1_unittest samples gtest_main samples/sample1.cc)
  cxx_executable(sample2_unittest samples gtest_main samples/sample2.cc)
  cxx_executable(sample3_unittest samples gtest_main)
  cxx_executable(sample4_unittest samples gtest_main samples/sample4.cc)
  cxx_executable(sample5_unittest samples gtest_main samples/sample1.cc)
  cxx_executable(sample6_unittest samples gtest_main)
  cxx_executable(sample7_unittest samples gtest_main)
  cxx_executable(sample8_unittest samples gtest_main)
  cxx_executable(sample9_unittest samples gtest)
  cxx_executable(sample10_unittest samples gtest)
endif()

########################################################################
#
# Google Test's own tests.
#
# You can skip this section if you aren't interested in testing
# Google Test itself.
#
# The tests are not built by default.  To build them, set the
# gtest_build_tests option to ON.  You can do it by running ccmake
# or specifying the -Dgtest_build_tests=ON flag when running cmake.

if (gtest_build_tests)
  # This must be set in the root directory for the tests to be run by
  # 'make test' or ctest.
  enable_testing()

  if (WIN32)
    file(GENERATE OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/$<CONFIG>/RunTest.ps1"
         CONTENT
"$project_bin = \"${CMAKE_BINARY_DIR}/bin/$<CONFIG>\"
$env:Path = \"$project_bin;$env:Path\"
& $args")
  elseif (MINGW OR CYGWIN)
    file(GENERATE OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/RunTest.ps1"
         CONTENT
"$project_bin = (cygpath --windows ${CMAKE_BINARY_DIR}/bin)
$env:Path = \"$project_bin;$env:Path\"
& $args")
  endif()

  ############################################################
  # C++ tests built with standard compiler flags.

  cxx_test(googletest-death-test-test gtest_main)
  cxx_test(gtest_environment_test gtest)
  cxx_test(googletest-filepath-test gtest_main)
  cxx_test(googletest-listener-test gtest_main)
  cxx_test(gtest_main_unittest gtest_main)
  cxx_test(googletest-message-test gtest_main)
  cxx_test(gtest_no_test_unittest gtest)
  cxx_test(googletest-options-test gtest_main)
  cxx_test(googletest-param-test-test gtest
    test/googletest-param-test2-test.cc)
  cxx_test(googletest-port-test gtest_main)
  cxx_test(gtest_pred_impl_unittest gtest_main)
  cxx_test(gtest_premature_exit_test gtest
    test/gtest_premature_exit_test.cc)
  cxx_test(googletest-printers-test gtest_main)
  cxx_test(gtest_prod_test gtest_main
    test/production.cc)
  cxx_test(gtest_repeat_test gtest)
  cxx_test(gtest_sole_header_test gtest_main)
  cxx_test(gtest_stress_test gtest)
  cxx_test(googletest-test-part-test gtest_main)
  cxx_test(gtest_throw_on_failure_ex_test gtest)
  cxx_test(gtest-typed-test_test gtest_main
    test/gtest-typed-test2_test.cc)
  cxx_test(gtest_unittest gtest_main)
  cxx_test(gtest-unittest-api_test gtest)
  cxx_test(gtest_skip_in_environment_setup_test gtest_main)
  cxx_test(gtest_skip_test gtest_main)

  ############################################################
  # C++ tests built with non-standard compiler flags.

  # MSVC 7.1 does not support STL with exceptions disabled.
  if (NOT MSVC OR MSVC_VERSION GREATER 1310)
    cxx_library(gtest_no_exception "${cxx_no_exception}"
      src/gtest-all.cc)
    cxx_library(gtest_main_no_exception "${cxx_no_exception}"
      src/gtest-all.cc src/gtest_main.cc)
  endif()
  cxx_library(gtest_main_no_rtti "${cxx_no_rtti}"
    src/gtest-all.cc src/gtest_main.cc)

  cxx_test_with_flags(gtest-death-test_ex_nocatch_test
    "${cxx_exception} -DGTEST_ENABLE_CATCH_EXCEPTIONS_=0"
    gtest test/googletest-death-test_ex_test.cc)
  cxx_test_with_flags(gtest-death-test_ex_catch_test
    "${cxx_exception} -DGTEST_ENABLE_CATCH_EXCEPTIONS_=1"
    gtest test/googletest-death-test_ex_test.cc)

  cxx_test_with_flags(gtest_no_rtti_unittest "${cxx_no_rtti}"
    gtest_main_no_rtti test/gtest_unittest.cc)

  cxx_shared_library(gtest_dll "${cxx_default}"
    src/gtest-all.cc src/gtest_main.cc)

  cxx_executable_with_flags(gtest_dll_test_ "${cxx_default}"
    gtest_dll test/gtest_all_test.cc)
  set_target_properties(gtest_dll_test_
                        PROPERTIES
                        COMPILE_DEFINITIONS "GTEST_LINKED_AS_SHARED_LIBRARY=1")

  ############################################################
  # Python tests.

  cxx_executable(googletest-break-on-failure-unittest_ test gtest)
  py_test(googletest-break-on-failure-unittest)

  py_test(gtest_skip_check_output_test)
  py_test(gtest_skip_environment_check_output_test)

  # Visual Studio .NET 2003 does not support STL with exceptions disabled.
  if (NOT MSVC OR MSVC_VERSION GREATER 1310)  # 1310 is Visual Studio .NET 2003
    cxx_executable_with_flags(
      googletest-catch-exceptions-no-ex-test_
      "${cxx_no_exception}"
      gtest_main_no_exception
      test/googletest-catch-exceptions-test_.cc)
  endif()

  cxx_executable_with_flags(
    googletest-catch-exceptions-ex-test_
    "${cxx_exception}"
    gtest_main
    test/googletest-catch-exceptions-test_.cc)
  py_test(googletest-catch-exceptions-test)

  cxx_executable(googletest-color-test_ test gtest)
  py_test(googletest-color-test)

  cxx_executable(googletest-env-var-test_ test gtest)
  py_test(googletest-env-var-test)

  cxx_executable(googletest-filter-unittest_ test gtest)
  py_test(googletest-filter-unittest)

  cxx_executable(gtest_help_test_ test gtest_main)
  py_test(gtest_help_test)

  cxx_executable(googletest-list-tests-unittest_ test gtest)
  py_test(googletest-list-tests-unittest)

  cxx_executable(googletest-output-test_ test gtest)
  py_test(googletest-output-test --no_stacktrace_support)

  cxx_executable(googletest-shuffle-test_ test gtest)
  py_test(googletest-shuffle-test)

  # MSVC 7.1 does not support STL with exceptions disabled.
  if (NOT MSVC OR MSVC_VERSION GREATER 1310)
    cxx_executable(googletest-throw-on-failure-test_ test gtest_no_exception)
    set_target_properties(googletest-throw-on-failure-test_
      PROPERTIES
      COMPILE_FLAGS "${cxx_no_exception}")
    py_test(googletest-throw-on-failure-test)
  endif()

  cxx_executable(googletest-uninitialized-test_ test gtest)
  py_test(googletest-uninitialized-test)

  cxx_executable(gtest_xml_outfile1_test_ test gtest_main)
  cxx_executable(gtest_xml_outfile2_test_ test gtest_main)
  py_test(gtest_xml_outfiles_test)
  py_test(googletest-json-outfiles-test)

  cxx_executable(gtest_xml_output_unittest_ test gtest)
  py_test(gtest_xml_output_unittest --no_stacktrace_support)

=== debian/changelog ===
scitokens-cpp (0.5.1-2) unstable; urgency=medium

  * Re-upload source only

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Wed, 20 Jan 2021 11:59:33 +0100

scitokens-cpp (0.5.1-1) unstable; urgency=medium

  * Initial release. (Closes: #977748)

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Sun, 20 Dec 2020 01:01:28 +0100

=== debian/control ===
Source: scitokens-cpp
Section: net
Priority: optional
Standards-Version: 4.5.1
Build-Depends:
 debhelper (>= 13),
 cmake,
 pkg-config,
 libcurl4-openssl-dev,
 libsqlite3-dev,
 libssl-dev,
 uuid-dev,
 googletest
Homepage: https://github.com/scitokens/scitokens-cpp
Maintainer: Mattias Ellert <mattias.ellert@physics.uu.se>
Vcs-Browser: https://salsa.debian.org/ellert/scitokens-cpp
Vcs-Git: https://salsa.debian.org/ellert/scitokens-cpp.git

Package: libscitokens0
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: C++ Implementation of the SciTokens Library
 This package implements a minimal library for creating and using
 SciTokens from C or C++.
 .
 SciTokens (https://scitokens.org) provide a token format for
 distributed authorization. The tokens are self-describing, can be
 verified in a distributed fashion (no need to contact the issuer to
 determine if the token is valid). This is convenient for a federated
 environment where several otherwise-independent storage endpoints
 want to delegate trust for an issuer for managing a storage
 allocation.

Package: libscitokens-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libscitokens0 (= ${binary:Version}),
 ${misc:Depends}
Description: Development files for scitokens-cpp
 Development files (header file, pkg-config file) for scitokens-cpp.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

%:
	dh $@

override_dh_auto_configure:
	# unbundle googletest
	rm -rf vendor/gtest
	ln -s /usr/src/googletest vendor/gtest
	dh_auto_configure -- \
	    -DLIB_INSTALL_DIR:PATH=lib/$(DEB_HOST_MULTIARCH) \
	    -DBUILD_UNITTESTS:BOOL=ON

override_dh_auto_test:
	cd obj-$(DEB_HOST_GNU_TYPE) && XDG_CACHE_HOME=$(CURDIR)/.cache ctest

override_dh_auto_clean:
	dh_auto_clean
	rm -rf .cache
	rm -rf vendor/gtest

## scitokens-cpp 0.6.2

=== debian/changelog ===
scitokens-cpp (0.6.2-2) unstable; urgency=medium

  * Allow compilation with openssl 3 (Closes: #1001433)
    Patch from Ubuntu: Steve Langasek <steve.langasek@canonical.com>

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Sun, 02 Jan 2022 09:25:41 +0100

scitokens-cpp (0.6.2-1) unstable; urgency=medium

  * Update to version 0.6.2

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Wed, 25 Aug 2021 10:36:24 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: scitokens-cpp
 Section: net
 Priority: optional
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Build-Depends:
  debhelper (>= 13),
  cmake,
@@ -10,7 +10,7 @@
  libsqlite3-dev,
  libssl-dev,
  uuid-dev,
- googletest
+ libgtest-dev
 Homepage: https://github.com/scitokens/scitokens-cpp
 Maintainer: Mattias Ellert <mattias.ellert@physics.uu.se>
 Vcs-Browser: https://salsa.debian.org/ellert/scitokens-cpp

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Allow compilation with openssl 3
export DEB_CFLAGS_MAINT_APPEND = -Wno-error=deprecated-declarations

%:
	dh $@

override_dh_auto_configure:
	rm -rf vendor/gtest # To make sure it is not used
	dh_auto_configure -- \
	    -DBUILD_UNITTESTS:BOOL=ON \
	    -DEXTERNAL_GTEST:BOOL=ON

override_dh_auto_test:
	cd obj-$(DEB_HOST_GNU_TYPE) && XDG_CACHE_HOME=$(CURDIR)/.cache ctest

override_dh_auto_clean:
	dh_auto_clean
	rm -rf .cache

## scitokens-cpp 0.6.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,8 +3,11 @@
 project( scitokens-cpp )
 
 option( BUILD_UNITTESTS "Build the scitokens-cpp unit tests" OFF )
+option( EXTERNAL_GTEST "Use an external/pre-installed copy of GTest" OFF )
 
 set( CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake )
+
+include(GNUInstallDirs)
 
 find_package( jwt-cpp REQUIRED )
 find_package( CURL REQUIRED )
@@ -66,33 +69,26 @@
 add_executable(scitokens-create src/create.cpp)
 target_link_libraries(scitokens-create SciTokens)
 
-if (NOT DEFINED LIB_INSTALL_DIR)
-  SET(LIB_INSTALL_DIR "lib")
-endif()
-
-if (NOT DEFINED INCLUDE_INSTALL_DIR)
-  SET(INCLUDE_INSTALL_DIR "include")
-endif()
-
 if( BUILD_UNITTESTS )
-
+if( NOT EXTERNAL_GTEST )
 include(ExternalProject)
 ExternalProject_Add(gtest
     PREFIX external/gtest
-    URL file://${PROJECT_SOURCE_DIR}/vendor/gtest
+    URL ${CMAKE_CURRENT_SOURCE_DIR}/vendor/gtest
     INSTALL_COMMAND :
 )
+endif()
 enable_testing()
 add_subdirectory(test)
 endif()
 
 install(
   TARGETS SciTokens
-  LIBRARY DESTINATION ${LIB_INSTALL_DIR} )
+  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} )
 
 install(
   FILES src/scitokens.h
-  DESTINATION ${INCLUDE_INSTALL_DIR}/scitokens )
+  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/scitokens )
 
 set_target_properties(
   SciTokens

=== debian/changelog ===
scitokens-cpp (0.6.3-1) stable; urgency=medium

  [ Dave Dykstra ]
  * Add support for building Debian packages on the OpenSUSE Build System
  * Add patch to jwt-cpp to update its picojson dependency in order to
    enable it to compile on Debian 11 and Ubuntu 21.04
  * Fix el7 build by requiring epel-rpm-macros

 -- root <root@e828ad46419b>  Wed, 20 Oct 2021 11:18:10 +0000

scitokens-cpp (0.6.2-2) stable; urgency=medium

  * Make the build require cmake3 instead of cmake

 -- Dave Dykstra <dwd@fnal.gov>  Thu, 26 Aug 2021 12:00:00 -0500

scitokens-cpp (0.6.2-1) stable; urgency=medium

  * Correct WLCG compat for condor read permissions

 -- Dave Dykstra <dwd@fnal.gov>  Thu, 26 Aug 2021 12:00:00 -0500

scitokens-cpp (0.6.1-1) stable; urgency=medium

  * Fix vector resize for el8+ builds

 -- Derek Weitzel <dweitzel@unl.edu>  Thu, 20 May 2021 12:00:00 -0500

scitokens-cpp (0.6.0-2) unstable; urgency=medium

  * Fix empty libscitokens0 package

 -- Tim Theisen <tim@cs.wisc.edu>  Fri, 26 Mar 2021 08:11:00 -0500

scitokens-cpp (0.6.0-1) unstable; urgency=medium

  * Fix compilation errors on c++11
  * Update to jwt-cpp-0.4.0 vendor
  * Change scitoken profile name to match spec, scitoken:2.0

 -- Derek Weitzel <dweitzel@unl.edu>  Tue, 09 Mar 2021 13:45:00 -0600

scitokens-cpp (0.5.1-3) unstable; urgency=low

  * Updated packaging for Debian

 -- Tim Theisen <tim@cs.wisc.edu>  Sun, 28 Feb 2021 16:02:24 -0600

scitokens-cpp (0.5.1-1) unstable; urgency=low

  * Initial release.

 -- Tim Theisen <tim@cs.wisc.edu>  Fri, 04 Dec 2020 10:54:24 -0600

## scitokens-cpp 0.7.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -80,11 +80,14 @@
 endif()
 enable_testing()
 add_subdirectory(test)
+
+else()
+get_directory_property(TARGETS BUILDSYSTEM_TARGETS)
+install(
+  TARGETS ${TARGETS} 
+  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
+  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} )
 endif()
-
-install(
-  TARGETS SciTokens
-  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} )
 
 install(
   FILES src/scitokens.h

=== test/CMakeLists.txt ===

add_executable(scitokens-gtest main.cpp)
add_dependencies(scitokens-gtest gtest)
include_directories("${PROJECT_SOURCE_DIR}/vendor/gtest/googletest/include")

if(EXTERNAL_GTEST)
    set(LIBGTEST "gtest")
else()
    set(LIBGTEST "${CMAKE_BINARY_DIR}/external/gtest/src/gtest-build/lib/libgtest.a")
endif()

target_link_libraries(scitokens-gtest SciTokens "${LIBGTEST}" pthread)

add_test(
  NAME
    unit
  COMMAND
    ${CMAKE_CURRENT_BINARY_DIR}/scitokens-gtest
  )

=== vendor/jwt-cpp/example/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8)
include(${CMAKE_TOOLCHAIN_FILE})

project(jwt-cpp-test)
find_package(jwt-cpp CONFIG REQUIRED)

add_executable(jwt-cpp-test print-claims.cpp)
target_link_libraries(jwt-cpp-test jwt-cpp::jwt-cpp)

=== vendor/jwt-cpp/tests/CMakeLists.txt ===
enable_testing()
include(GoogleTest)

set(TEST_SOURCES
    ${CMAKE_CURRENT_SOURCE_DIR}/BaseTest.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/ClaimTest.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/HelperTest.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/TestMain.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/TokenFormatTest.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/TokenTest.cpp)

add_executable(jwt-cpp-test ${TEST_SOURCES})
target_compile_options(jwt-cpp-test PRIVATE 
    $<$<CXX_COMPILER_ID:MSVC>:/W4>
    $<$<CXX_COMPILER_ID:GNU>:-Wall -Wextra -Wpedantic>
    $<$<CXX_COMPILER_ID:Clang>:-Weverything>)
target_link_libraries(jwt-cpp-test PRIVATE jwt-cpp::jwt-cpp gtest gtest_main pthread)

gtest_add_tests(TARGET jwt-cpp-test)

=== debian/changelog ===
scitokens-cpp (0.7.0-2) unstable; urgency=medium

  * Re-upload source only

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Tue, 22 Feb 2022 15:53:26 +0100

scitokens-cpp (0.7.0-1) unstable; urgency=medium

  * Update to version 0.7.0
  * Add scitokens-cpp binary package

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Sat, 19 Feb 2022 14:02:05 +0100

=== debian/control ===
--- 
+++ 
@@ -43,4 +43,15 @@
  libscitokens0 (= ${binary:Version}),
  ${misc:Depends}
 Description: Development files for scitokens-cpp
- Development files (header file, pkg-config file) for scitokens-cpp.
+ Development files (header files) for scitokens-cpp.
+
+Package: scitokens-cpp
+Architecture: any
+Multi-Arch: foreign
+Section: net
+Depends:
+ libscitokens0 (= ${binary:Version}),
+ ${shlibs:Depends},
+ ${misc:Depends}
+Description: Binaries for scitokens-cpp
+ Binaries for creating, verifying and testing scitokens.

=== debian/rules ===
--- 
+++ 
@@ -8,7 +8,6 @@
 	dh $@
 
 override_dh_auto_configure:
-	rm -rf vendor/gtest # To make sure it is not used
 	dh_auto_configure -- \
 	    -DBUILD_UNITTESTS:BOOL=ON \
 	    -DEXTERNAL_GTEST:BOOL=ON

## scitokens-cpp 0.7.1

=== debian/changelog ===
scitokens-cpp (0.7.1-1) unstable; urgency=medium

  * Update to version 0.7.1

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Thu, 23 Jun 2022 11:26:07 +0200

## scitokens-cpp 0.7.2

=== debian/changelog ===
scitokens-cpp (0.7.2-1) unstable; urgency=medium

  * Update to version 0.7.2

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Tue, 01 Nov 2022 14:11:21 +0100

## scitokens-cpp 0.7.3

=== CMakeLists.txt ===

cmake_minimum_required( VERSION 3.10)

project( scitokens-cpp 
	DESCRIPTION "A C++ Library to interface to scitokens"
	VERSION 0.7.0
	LANGUAGES CXX)

option( SCITOKENS_BUILD_UNITTESTS "Build the scitokens-cpp unit tests" OFF )
option( SCITOKENS_EXTERNAL_GTEST "Use an external/pre-installed copy of GTest" OFF )
option( SCTOKENS_WARNINGS_ARE_ERRORS "Turn compiler warnings into build errors" OFF)

set( CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake;${CMAKE_MODULE_PATH}" )

set( CMAKE_BUILD_TYPE RelWithDebInfo) # -g -O2

include(GNUInstallDirs)

find_package( jwt-cpp REQUIRED )
find_package( CURL REQUIRED )
find_package( UUID REQUIRED )

if( APPLE )

find_package( OpenSSL REQUIRED )
find_package( Sqlite3 REQUIRED )
set(LIBCRYPTO_INCLUDE_DIRS ${OPENSSL_INCLUDE_DIR})
set(LIBCRYPTO_LIBRARIES ${OPENSSL_CRYPTO_LIBRARY})
set(CMAKE_MACOSX_RPATH ON)

elseif( UNIX )

include (FindPkgConfig)
pkg_check_modules(LIBCRYPTO REQUIRED libcrypto)
pkg_check_modules(OPENSSL REQUIRED openssl)
pkg_check_modules(SQLITE REQUIRED sqlite3)

endif()

add_library(SciTokens SHARED src/scitokens.cpp src/scitokens_internal.cpp src/scitokens_cache.cpp)
target_compile_features(SciTokens PUBLIC cxx_std_11) # Use at least C++11 for building and when linking to scitokens
target_compile_options(SciTokens PRIVATE $<$<CXX_COMPILER_ID:GNU>:-Wall $<$<BOOL:${SCITOKENS_WARNINGS_ARE_ERRORS}>:-Werror>>)
target_include_directories(SciTokens PUBLIC ${JWT_CPP_INCLUDES} "${PROJECT_SOURCE_DIR}/src" PRIVATE ${CURL_INCLUDES} ${OPENSSL_INCLUDE_DIRS} ${LIBCRYPTO_INCLUDE_DIRS} ${SQLITE_INCLUDE_DIRS}  ${UUID_INCLUDE_DIRS})

target_link_libraries(SciTokens PUBLIC ${OPENSSL_LIBRARIES} ${LIBCRYPTO_LIBRARIES} ${CURL_LIBRARIES} ${SQLITE_LIBRARIES} ${UUID_LIBRARIES})
if (UNIX)
# pkg_check_modules fails to return an absolute path on RHEL7.  Set the
# link directories accordingly.
target_link_directories(SciTokens PUBLIC ${OPENSSL_LIBRARY_DIRS} ${LIBCRYPTO_LIBRARY_DIRS})
endif()

if ( NOT APPLE AND UNIX )
set_target_properties(SciTokens PROPERTIES LINK_FLAGS "-Wl,--version-script=${PROJECT_SOURCE_DIR}/configs/export-symbols")
endif()

add_executable(scitokens-test src/test.cpp)
#target_include_directories(scitokens-test PRIVATE "${PROJECT_SOURCE_DIR}" ${JWT_CPP_INCLUDES} ${CURL_INCLUDES} ${OPENSSL_INCLUDE_DIRS} ${LIBCRYPTO_INCLUDE_DIRS} ${SQLITE_INCLUDE_DIRS}  ${UUID_INCLUDE_DIRS})
target_include_directories(scitokens-test PRIVATE "${PROJECT_SOURCE_DIR}" ${JWT_CPP_INCLUDES})
target_link_libraries(scitokens-test SciTokens)
target_compile_options(scitokens-test PRIVATE $<$<CXX_COMPILER_ID:GNU>:-Wall $<$<BOOL:${SCITOKENS_WARNINGS_ARE_ERRORS}>:-Werror>>)

add_executable(scitokens-verify src/verify.cpp)
target_link_libraries(scitokens-verify SciTokens)
target_compile_options(scitokens-verify PRIVATE $<$<CXX_COMPILER_ID:GNU>:-Wall $<$<BOOL:${SCITOKENS_WARNINGS_ARE_ERRORS}>:-Werror>>)

add_executable(scitokens-test-access src/test_access.cpp)
target_link_libraries(scitokens-test-access SciTokens)
target_compile_options(scitokens-test-access PRIVATE $<$<CXX_COMPILER_ID:GNU>:-Wall $<$<BOOL:${SCITOKENS_WARNINGS_ARE_ERRORS}>:-Werror>>)

add_executable(scitokens-list-access src/list_access.cpp)
target_link_libraries(scitokens-list-access SciTokens)
target_compile_options(scitokens-list-access PRIVATE $<$<CXX_COMPILER_ID:GNU>:-Wall $<$<BOOL:${SCITOKENS_WARNINGS_ARE_ERRORS}>:-Werror>>)

add_executable(scitokens-create src/create.cpp)
target_link_libraries(scitokens-create SciTokens)
target_compile_options(scitokens-create PRIVATE $<$<CXX_COMPILER_ID:GNU>:-Wall $<$<BOOL:${SCITOKENS_WARNINGS_ARE_ERRORS}>:-Werror>>)

get_directory_property(TARGETS BUILDSYSTEM_TARGETS)
install(
  TARGETS ${TARGETS} 
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} )

install(
  FILES src/scitokens.h
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/scitokens )

set_target_properties(
  SciTokens
  PROPERTIES
  VERSION   "0.0.2"
  SOVERSION "0"
  )

if( SCITOKENS_BUILD_UNITTESTS )
	if( NOT SCITOKENS_EXTERNAL_GTEST )
include(ExternalProject)
ExternalProject_Add(gtest
    PREFIX external/gtest
    URL ${CMAKE_CURRENT_SOURCE_DIR}/vendor/gtest
    INSTALL_COMMAND :
)
endif()
enable_testing()
add_subdirectory(test)
endif()

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 add_dependencies(scitokens-gtest gtest)
 include_directories("${PROJECT_SOURCE_DIR}/vendor/gtest/googletest/include")
 
-if(EXTERNAL_GTEST)
+if(SCITOKENS_EXTERNAL_GTEST)
     set(LIBGTEST "gtest")
 else()
     set(LIBGTEST "${CMAKE_BINARY_DIR}/external/gtest/src/gtest-build/lib/libgtest.a")

=== debian/changelog ===
scitokens-cpp (0.7.3-1) unstable; urgency=medium

  * Update to version 0.7.3

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Sun, 06 Nov 2022 21:34:51 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: scitokens-cpp
 Section: net
 Priority: optional
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Build-Depends:
  debhelper (>= 13),
  cmake,

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	    -DSCITOKENS_BUILD_UNITTESTS:BOOL=ON \
	    -DSCITOKENS_EXTERNAL_GTEST:BOOL=ON

override_dh_auto_test:
	cd obj-$(DEB_HOST_GNU_TYPE) && XDG_CACHE_HOME=$(CURDIR)/.cache ctest

override_dh_auto_clean:
	dh_auto_clean
	rm -rf .cache

## scitokens-cpp 1.0.2

=== debian/changelog ===
scitokens-cpp (1.0.2-1) stable; urgency=medium

  [ Derek Weitzel ]
  * Add support for API-configurable cache home
  * Fix enforcer_acl_free logic
  * scitokens_internal: catch matching exception type after jwt-cpp update

 -- Tim Theisen <tim@cs.wisc.edu>  Mon, 24 Jul 2023 20:13:43 +0000

scitokens-cpp (1.0.1-1) stable; urgency=medium

  * Fix bug in generate acls which would cause a timeout

 -- Derek Weitzel <dweitzel@unl.edu>  Wed, 26 Apr 2023 12:00:00 -0500

scitokens-cpp (1.0.0-1) stable; urgency=medium

  * Add async API for parsing and verifying tokens
  * Add configuration API
  * Make nbf claim optional for non-scitokens tokens
  * Update to OpenSSL 3.0

 -- Derek Weitzel <dweitzel@unl.edu>  Tue, 21 Mar 2023 10:18:59 -0500

scitokens-cpp (0.7.3-1) stable; urgency=medium

  * Retry failed key renewal every 5 minutes

 -- Derek Weitzel <dweitzel@unl.edu>  Tue, 01 Nov 2022 08:29:22 -0500

scitokens-cpp (0.7.2-1) stable; urgency=medium

  * Add curl timeout of 4 seconds for update, and 30 for expired keys

 -- Derek Weitzel <dweitzel@unl.edu>  Mon, 31 Oct 2022 15:35:17 -0500

scitokens-cpp (0.7.1-1) stable; urgency=medium

  * Add scitokens-* binaries to the package
  * Bug: close sqlite db handle on return

 -- Derek Weitzel <dweitzel@unl.edu>  Wed, 22 Jun 2022 11:26:18 -0500

scitokens-cpp (0.7.0-1) stable; urgency=medium

  * Changes from static analysis
  * If only one key is available, do not error on no kid
  * Support at+jwt profile

 -- Derek Weitzel <dweitzel@unl.edu>  Fri, 18 Feb 2022 13:16:18 -0600

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: scitokens-cpp
 Section: net
 Priority: optional
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Build-Depends:
  debhelper (>= 13),
  cmake,

=== debian/rules ===
--- 
+++ 
@@ -10,7 +10,12 @@
 	    -DSCITOKENS_EXTERNAL_GTEST:BOOL=ON
 
 override_dh_auto_test:
-	cd obj-$(DEB_HOST_GNU_TYPE) && XDG_CACHE_HOME=$(CURDIR)/.cache ctest
+	# Filter out tests that require network connection
+	# Use a key cache directory outside HOME since HOME might not exit
+	cd obj-$(DEB_HOST_GNU_TYPE) && \
+		GTEST_FILTER=-KeycacheTest.RefreshTest:KeycacheTest.RefreshExpiredTest \
+		XDG_CACHE_HOME=$(CURDIR)/.cache \
+		ctest --output-on-failure
 
 override_dh_auto_clean:
 	dh_auto_clean

## scitokens-cpp 1.1.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,12 +3,11 @@
 
 project( scitokens-cpp 
 	DESCRIPTION "A C++ Library to interface to scitokens"
-	VERSION 0.7.0
+	VERSION 1.0.2
 	LANGUAGES CXX)
 
 option( SCITOKENS_BUILD_UNITTESTS "Build the scitokens-cpp unit tests" OFF )
 option( SCITOKENS_EXTERNAL_GTEST "Use an external/pre-installed copy of GTest" OFF )
-option( SCTOKENS_WARNINGS_ARE_ERRORS "Turn compiler warnings into build errors" OFF)
 
 set( CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake;${CMAKE_MODULE_PATH}" )
 
@@ -39,7 +38,6 @@
 
 add_library(SciTokens SHARED src/scitokens.cpp src/scitokens_internal.cpp src/scitokens_cache.cpp)
 target_compile_features(SciTokens PUBLIC cxx_std_11) # Use at least C++11 for building and when linking to scitokens
-target_compile_options(SciTokens PRIVATE $<$<CXX_COMPILER_ID:GNU>:-Wall $<$<BOOL:${SCITOKENS_WARNINGS_ARE_ERRORS}>:-Werror>>)
 target_include_directories(SciTokens PUBLIC ${JWT_CPP_INCLUDES} "${PROJECT_SOURCE_DIR}/src" PRIVATE ${CURL_INCLUDES} ${OPENSSL_INCLUDE_DIRS} ${LIBCRYPTO_INCLUDE_DIRS} ${SQLITE_INCLUDE_DIRS}  ${UUID_INCLUDE_DIRS})
 
 target_link_libraries(SciTokens PUBLIC ${OPENSSL_LIBRARIES} ${LIBCRYPTO_LIBRARIES} ${CURL_LIBRARIES} ${SQLITE_LIBRARIES} ${UUID_LIBRARIES})
@@ -55,25 +53,20 @@
 
 add_executable(scitokens-test src/test.cpp)
 #target_include_directories(scitokens-test PRIVATE "${PROJECT_SOURCE_DIR}" ${JWT_CPP_INCLUDES} ${CURL_INCLUDES} ${OPENSSL_INCLUDE_DIRS} ${LIBCRYPTO_INCLUDE_DIRS} ${SQLITE_INCLUDE_DIRS}  ${UUID_INCLUDE_DIRS})
-target_include_directories(scitokens-test PRIVATE "${PROJECT_SOURCE_DIR}" ${JWT_CPP_INCLUDES})
+target_include_directories(scitokens-test PRIVATE "${PROJECT_SOURCE_DIR}" ${JWT_CPP_INCLUDES} ${LIBCRYPTO_INCLUDE_DIRS})
 target_link_libraries(scitokens-test SciTokens)
-target_compile_options(scitokens-test PRIVATE $<$<CXX_COMPILER_ID:GNU>:-Wall $<$<BOOL:${SCITOKENS_WARNINGS_ARE_ERRORS}>:-Werror>>)
 
 add_executable(scitokens-verify src/verify.cpp)
 target_link_libraries(scitokens-verify SciTokens)
-target_compile_options(scitokens-verify PRIVATE $<$<CXX_COMPILER_ID:GNU>:-Wall $<$<BOOL:${SCITOKENS_WARNINGS_ARE_ERRORS}>:-Werror>>)
 
 add_executable(scitokens-test-access src/test_access.cpp)
 target_link_libraries(scitokens-test-access SciTokens)
-target_compile_options(scitokens-test-access PRIVATE $<$<CXX_COMPILER_ID:GNU>:-Wall $<$<BOOL:${SCITOKENS_WARNINGS_ARE_ERRORS}>:-Werror>>)
 
 add_executable(scitokens-list-access src/list_access.cpp)
 target_link_libraries(scitokens-list-access SciTokens)
-target_compile_options(scitokens-list-access PRIVATE $<$<CXX_COMPILER_ID:GNU>:-Wall $<$<BOOL:${SCITOKENS_WARNINGS_ARE_ERRORS}>:-Werror>>)
 
 add_executable(scitokens-create src/create.cpp)
 target_link_libraries(scitokens-create SciTokens)
-target_compile_options(scitokens-create PRIVATE $<$<CXX_COMPILER_ID:GNU>:-Wall $<$<BOOL:${SCITOKENS_WARNINGS_ARE_ERRORS}>:-Werror>>)
 
 get_directory_property(TARGETS BUILDSYSTEM_TARGETS)
 install(

=== vendor/jwt-cpp/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

# HUNTER_ENABLED is always set if this package is included in a project using hunter (HunterGate sets it) In this case
# we will use hunter as well to stay consistent. If not the use can supply it on configure to force using hunter.
if(HUNTER_ENABLED)
  include("cmake/HunterGate.cmake")
  huntergate(URL "https://github.com/cpp-pm/hunter/archive/v0.23.314.tar.gz" SHA1
             "95c47c92f68edb091b5d6d18924baabe02a6962a")
  message(STATUS "jwt-cpp: using hunter for dependency resolution")
endif()

project(jwt-cpp)

option(JWT_BUILD_EXAMPLES "Configure CMake to build examples (or not)" ON)
option(JWT_BUILD_TESTS "Configure CMake to build tests (or not)" OFF)
option(JWT_ENABLE_COVERAGE "Enable code coverage testing" OFF)
option(JWT_ENABLE_FUZZING "Enable fuzz testing" OFF)

option(JWT_EXTERNAL_PICOJSON "Use find_package() to locate picojson, provided to integrate with package managers" OFF)
option(JWT_DISABLE_BASE64 "Do not include the base64 implementation from this library" OFF)
option(JWT_DISABLE_PICOJSON "Do not provide the picojson template specialiaze" OFF)

set(JWT_SSL_LIBRARY_OPTIONS OpenSSL LibreSSL wolfSSL)
set(JWT_SSL_LIBRARY OpenSSL CACHE STRING "Determines which SSL library to build with")
set_property(CACHE JWT_SSL_LIBRARY PROPERTY STRINGS ${JWT_SSL_LIBRARY_OPTIONS})

set(JWT_JSON_TRAITS_OPTIONS boost-json danielaparker-jsoncons kazuho-picojson nlohmann-json)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake")

if(NOT JWT_SSL_LIBRARY IN_LIST JWT_SSL_LIBRARY_OPTIONS)
  message(FATAL_ERROR "JWT_SSL_LIBRARY must be one of ${JWT_SSL_LIBRARY_OPTIONS}")
endif()

# If Hunter is enabled, we configure it to resolve OpenSSL and warn the user if he selected an option not supported by
# hunter. We fall back to the system library in this case.
if(HUNTER_ENABLED)
  if(${JWT_SSL_LIBRARY} MATCHES "OpenSSL")
    hunter_add_package(OpenSSL)
  elseif(${JWT_SSL_LIBRARY} MATCHES "LibreSSL")
    message(WARNING "Hunter does not support LibreSSL yet, the system library will be used (if available)")
  elseif(${JWT_SSL_LIBRARY} MATCHES "wolfSSL")
    message(WARNING "Hunter does not support wolfSSL yet, the system library will be used (if available)")
  endif()
  if(JWT_EXTERNAL_PICOJSON)
    message(WARNING "Hunter does not support picojson yet, the system library will be used (if available)")
  endif()
endif()

# Lookup dependencies
if(${JWT_SSL_LIBRARY} MATCHES "OpenSSL")
  find_package(OpenSSL 1.0.1 REQUIRED)
elseif(${JWT_SSL_LIBRARY} MATCHES "LibreSSL")
  find_package(LibreSSL 3.0.0 REQUIRED)
elseif(${JWT_SSL_LIBRARY} MATCHES "wolfSSL")
  find_package(PkgConfig REQUIRED)
  pkg_check_modules(wolfssl REQUIRED IMPORTED_TARGET wolfssl)
  list(TRANSFORM wolfssl_INCLUDE_DIRS APPEND "/wolfssl") # This is required to access OpenSSL compatability API
endif()

if(JWT_EXTERNAL_PICOJSON)
  find_package(picojson 1.3.0 REQUIRED)
endif()

set(JWT_INCLUDE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/include)
set(JWT_HEADER_FILES ${JWT_INCLUDE_PATH}/jwt-cpp/jwt.h)
foreach(traits ${JWT_JSON_TRAITS_OPTIONS})
  list(APPEND JWT_HEADER_FILES ${JWT_INCLUDE_PATH}/jwt-cpp/traits/${traits}/defaults.h
       ${JWT_INCLUDE_PATH}/jwt-cpp/traits/${traits}/traits.h)
endforeach()

if(NOT JWT_DISABLE_BASE64)
  list(APPEND JWT_HEADER_FILES ${JWT_INCLUDE_PATH}/jwt-cpp/base.h)
endif()

add_library(jwt-cpp INTERFACE)
add_library(jwt-cpp::jwt-cpp ALIAS jwt-cpp) # To match export
target_compile_features(jwt-cpp INTERFACE cxx_std_11)
if(JWT_DISABLE_BASE64)
  target_compile_definitions(jwt-cpp INTERFACE JWT_DISABLE_BASE64)
endif()
if(JWT_DISABLE_PICOJSON)
  target_compile_definitions(jwt-cpp INTERFACE JWT_DISABLE_PICOJSON)
endif()

include(GNUInstallDirs)
include(CMakePackageConfigHelpers)
target_include_directories(jwt-cpp INTERFACE $<BUILD_INTERFACE:${JWT_INCLUDE_PATH}>
                                             $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)

if(${JWT_SSL_LIBRARY} MATCHES "OpenSSL")
  target_link_libraries(jwt-cpp INTERFACE OpenSSL::SSL OpenSSL::Crypto)
endif()

if(${JWT_SSL_LIBRARY} MATCHES "LibreSSL")
  target_link_libraries(jwt-cpp INTERFACE LibreSSL::TLS)
endif()

if(${JWT_SSL_LIBRARY} MATCHES "wolfSSL")
  target_link_libraries(jwt-cpp INTERFACE PkgConfig::wolfssl)
  # This is required to access OpenSSL compatability API
  target_include_directories(jwt-cpp INTERFACE ${wolfssl_INCLUDE_DIRS})
  target_compile_definitions(jwt-cpp INTERFACE OPENSSL_EXTRA OPENSSL_ALL)
endif()

if(JWT_EXTERNAL_PICOJSON)
  target_link_libraries(jwt-cpp INTERFACE picojson::picojson>)
endif()

# Hunter needs relative paths so the files are palced correctly
if(NOT JWT_CMAKE_FILES_INSTALL_DIR)
  set(JWT_CMAKE_FILES_INSTALL_DIR cmake)
endif()

configure_package_config_file(
  ${CMAKE_CURRENT_LIST_DIR}/cmake/jwt-cpp-config.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/jwt-cpp-config.cmake
  INSTALL_DESTINATION ${JWT_CMAKE_FILES_INSTALL_DIR} PATH_VARS JWT_EXTERNAL_PICOJSON JWT_SSL_LIBRARY)
write_basic_package_version_file(${CMAKE_CURRENT_BINARY_DIR}/jwt-cpp-config-version.cmake VERSION 0.6.0
                                 COMPATIBILITY ExactVersion)

install(TARGETS jwt-cpp EXPORT jwt-cpp-targets PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
install(EXPORT jwt-cpp-targets NAMESPACE jwt-cpp:: FILE jwt-cpp-targets.cmake
        DESTINATION ${JWT_CMAKE_FILES_INSTALL_DIR})
install(DIRECTORY ${JWT_INCLUDE_PATH}/jwt-cpp DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
if(NOT JWT_EXTERNAL_PICOJSON AND NOT JWT_DISABLE_PICOJSON)
  install(FILES ${JWT_INCLUDE_PATH}/picojson/picojson.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/picojson)
endif()
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/jwt-cpp-config.cmake ${CMAKE_CURRENT_BINARY_DIR}/jwt-cpp-config-version.cmake
        DESTINATION ${JWT_CMAKE_FILES_INSTALL_DIR})

if(JWT_BUILD_EXAMPLES)
  add_subdirectory(example)
endif()

if(JWT_BUILD_TESTS)
  add_subdirectory(tests)
endif()

if(JWT_ENABLE_FUZZING)
  add_subdirectory(tests/fuzz)
endif()

=== debian/changelog ===
scitokens-cpp (1.1.0-1) stable; urgency=medium

  * Allow the scitokens library user to setup a custom CA file
  * Fix typecast errors in scitoken_status_get_*() that caused async queries to fail
  * Fix logic error in deserialize_continue() that caused async deserialization to fail

 -- Tim Theisen <tim@cs.wisc.edu>  Tue, 07 Nov 2023 22:03:46 +0000

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Standards-Version: 4.6.2
 Build-Depends:
- debhelper (>= 13),
+ debhelper-compat (= 13),
  cmake,
  pkg-config,
  libcurl4-openssl-dev,
@@ -48,7 +48,6 @@
 Package: scitokens-cpp
 Architecture: any
 Multi-Arch: foreign
-Section: net
 Depends:
  libscitokens0 (= ${binary:Version}),
  ${shlibs:Depends},
